#include <X11/Xlib.h>
#include <X11/keysym.h>
#include <X11/Xutil.h> //xsizehints
#include "string.h"
#include "stdlib.h"
//#include "stdio.h";
#include "time.h"
//unsigned int sleep(unsigned int seconds);
#include <unistd.h> //usleep
#include <ft2build.h>
#include FT_FREETYPE_H
#include "xdotool/xdo.h"
#define xdo_keysequence xdo_send_keysequence_window
#define DEFAULT_DELAY 12
char *get_udir()
{	static char *udir;if(!udir)
{		udir=getenv("HOME");if(udir&&udir[0]&&udir[0]=='/');else
{			dprintf(2,"warning: HOME not set\n");udir="/user";
}}	return udir;}
#define strdupf(...) ({char *llstr;int lllen=snprintf(NULL,0,__VA_ARGS__);llstr=malloc(lllen+1);snprintf(llstr,lllen+1,__VA_ARGS__);llstr;})
#define frep(s,expr1) ({char *macvar=s;s=expr1;free(macvar);s;})
//typedef struct rect{int x,y,w,h;}rect;
#include "pic.c"

#define betw(a,b,c) ((a)<(b)&&(b)<(c))
#define check_rect_mac(rx,ry,rw,rh) (betw(rx,mx,rx+rw)&&betw(ry,my,ry+rh))
inline char check_rect(int rx,int ry,int rw,int rh,int mx,int my) {return check_rect_mac(rx,ry,rw,rh);};
inline time_t abstime(time_t s)
{	return (s<0)?-s:s
;
}char dontfocus(Display *dpy, Window w)
{	char out=0 ;XWMHints *hints=XAllocWMHints() ;if(!hints) return 1;
	hints->flags=InputHint ;hints->input=False;
	XSetWMHints(dpy,w,hints);
	XFree(hints) ;return out;
}void x_draw_rect_dashed(Display *dpy,Drawable drw1,GC gc1,int base_x,int base_y,int w,int h)
{	int x,y;short dw=1,dl=4;
	x=0;while(x+dl<=w)
{		XFillRectangle(dpy,drw1, gc1, base_x+x,base_y,dl,dw);
		XFillRectangle(dpy,drw1, gc1, base_x+w-(x+dl-1),base_y+h,dl,dw);
		x+=dl*2;
}	y=0;while(y+dl<=h)
{		XFillRectangle(dpy,drw1, gc1, base_x,base_y+y,dw,dl);
		XFillRectangle(dpy,drw1, gc1, base_x+w,base_y+h-(y+dl-1),dw,dl);
		y+=dl*2
;
}}XWindowAttributes attr;
XSetWindowAttributes attri;
Display *dpy;GC gc1;Drawable drw1,drw1b,drw2;int drw1w,drw1h;
Window root;int rootdepth;
Window w1;
char ending;
char *tip_w_fn="/tmp/keyb_tip"
;
FT_Library ft_lib;FT_Face ft_font1,ft_font1b;char ft_ok;
pic font1,font1b;rect *font1_rarr,*font1b_rarr
;
//Drawable drw1=XCreatePixmap(dpy,root,drw1w,drw1h,rootdepth);
//XSetForeground(dpy,gc1,-1);XFillRectangle(dpy,drw1, gc1, 0,0,drw1w,drw1h);XSetForeground(dpy,gc1,0);
//XFillRectangle(dpy,drw1, gc1, base_x+x,base_y+y,1,1)
;
//xtextwidth,xcreateimage,not-pixmapfromdata,not-xcopyplane;
rect *x_font_getrect(rect *rarr,char *charcode)/*check NULL and ->w==0||->h==0*/
{	if(charcode&&charcode[0]&&charcode[1]=='\0')return &rarr[charcode[0]];
	else return NULL
;
}void font_draw_ft(pic *pic1,int base_x,int base_y,FT_GlyphSlot slot)
{	/*see mtpaint/ft_draw_bitmap*/;
	char *src=slot->bitmap.buffer;
	int x1=slot->bitmap_left,y1=slot->bitmap_top;
	int x,y,w=slot->bitmap.width,h=slot->bitmap.rows;
	y=0;while(y<h)
{		x=0;while(x<w)
{			unsigned char *src_a=src+y*w+x;if(1)
{				if(src_a[0]>(0xFF/4))
{					char *a=pnt_pic(pic1,base_x+x,base_y-y1+y);if(a)a[0]=0xFF/*bl*//*y1 instead of h*/;
}}			x+=1;
}		y+=1
;
}}pic font_pic_ft(FT_Face ft_font1,short cw,short ch,rect **rarr_p)
{	FT_Set_Pixel_Sizes(ft_font1,cw+2,ch+2)
;
	int gw=16,gh=8,gcw=cw*3,gch=ch*3;
	int pic1w=gw*gcw,pic1h=gh*gch;
	pic pic1=new_pic(pic1w,pic1h,1);
	qrect_pic(&pic1,0,0,pic1w,pic1h,0/*wh*/);
	rect *rarr=malloc(sizeof(rect)*gw*gh)
;
	int gx,gy=0;while(gy<gh)
{		gx=0;while(gx<gw)
{			FT_ULong charcode=gy*16+gx;
			FT_UInt charcode_i=FT_Get_Char_Index(ft_font1,charcode);
			FT_Load_Glyph(ft_font1,charcode_i,0);
			FT_GlyphSlot slot=ft_font1->glyph;
			FT_Render_Glyph(slot,0);
			if(slot->format==FT_GLYPH_FORMAT_BITMAP)
{				char charcode2[]={charcode,0};
				rect *r=x_font_getrect(rarr,charcode2);if(r)
{					r->x=gx*gcw;r->y=gy*gch;r->w=gcw;r->h=gch;
					//int x=slot->bitmap_left,y=slot->bitmap_top;
					int w=slot->bitmap.width,h=slot->bitmap.rows;
					font_draw_ft(&pic1,r->x+r->w/2-w/2,r->y+r->h/2+ch/2,slot);
}}			gx+=1;
}		gy+=1;
}	*rarr_p=rarr;return pic1
;
}void x_copy_pic(Drawable drw1,int r_x,int r_y,pic *src_p,rect src_r,int transp_color)/*currently works with src_p->bypp=1. currently sets non-transp. to bl.*/
{	//XSetForeground(dpy,gc1,-1);XFillRectangle(dpy,drw1, gc1, 0,0,drw1w,drw1h);XSetForeground(dpy,gc1,0);
	//rect r;set_rect(r,r_x,r_y,src_r.w,src_r.h);
	rect r=src_r;pic *p=src_p;
	int x,y,x2=r.x+r.w,y2=r.y+r.h;
	y=r.y;while(y<y2)
{		char *a,*a1=(y<p->h)?p->a+p->p*y:NULL;
		x=r.x;while(x<x2)
{			a=(a1&&x<p->w)?a1+x*p->bypp:NULL;if(a)
{				if(a[0]!=transp_color)XFillRectangle(dpy,drw1, gc1, r_x+(x-r.x),r_y+(y-r.y),1,1);
}			x+=1;
}		y+=1
;
}}void x_font_str1(Drawable drw1,int base_x,int base_y,int base_w,pic *font1,rect *rarr,short cw,short ch,char *str1)
{	int len_str1=strlen(str1);
	short cw2=cw;if(len_str1*cw>base_w)cw2=base_w/len_str1;
	int x=base_x+base_w/2-cw2*len_str1/2,y=base_y;
	int n=0;while(n<len_str1)
{		char charcode[]={str1[n],0};
		rect *r=x_font_getrect(rarr,charcode);
		if(r&&r->w&&r->h)
{			x_copy_pic(drw1,x+cw2/2-r->w/2,y+ch/2-r->h/2,font1,*r,0/*wh*/);
}		n+=1;x+=cw2
;
}}void draw_text(Display *dpy,/*GC (*gc1)*/GC *gc1p,Drawable drw1,Drawable w1,int x,int y,int ww,char *str){
	#define gc1 (*gc1p)
	char cwid=0b110,bbh=20;
	char *str1=str;int x1=x,y1=y;char *s=str;int w_s=0;
	XSetForeground(dpy,gc1,-1);XFillRectangle(dpy,drw1, gc1, x1,y1,ww,drw1h);XSetForeground(dpy,gc1,0);
	while(1)
{		char c=str[0];char w_c;char flag=1,flag2=0,last=0;if(c=='\0')last=1;
		else if(strchr("\r\n",c)){flag2=1;flag=2;w_c=0;}
		else
{			flag=2;if(c==' ')w_c=cwid/2;else if(c=='\t')w_c=4*cwid;else{w_c=cwid;flag=0;};
			if(x+w_s+w_c-x1>ww)flag2=1;
}		if(flag||flag2)
{			if(s<str)
{				char *string=s;XDrawString(dpy,drw1, gc1,x,15+y, string, str-s);
}			if(flag2)
{				x=x1;y+=bbh;
}			else x+=w_s;
			s=str;w_s=flag2?w_c:0;
			if(flag==2)
{				x+=w_c;
				s+=1;
}}		else w_s+=w_c;
		if(last)break;else str+=1;
}	XCopyArea(dpy,drw1,w1,gc1,x1,y1,ww,y+bbh,x1,y1);
	return 0;
	#undef gc1
}//todo if argc-1>1 exec each
;
int keyb_mods_n=0,keyb_mods_len=6;
char keyb_mods[6];
signed char check_mod(int n)
{	if(keyb_mods_n<=n&&n<keyb_mods_n+keyb_mods_len)return keyb_mods[n];
	else return -1;}
#define check_mod1(n) (keyb_mods[n])
#define set_mod(n,val) (keyb_mods[n]=val)
void keyb_mods_next(int *n_p)/*-1 separates*//*might need 2nd counter*/{
	#define n (*n_p)
	if(n<0)n=keyb_mods_n;else
{		if(n+1<keyb_mods_n+keyb_mods_len)n+=1;else n=-1;}
	#undef n

}void check_other_key(int n,char *name)
{	if(n==-1);
	else if(n==5)ending=1;
	//else if(n==6/*hold*/);
	else if(n==21/*word*/)
{		system("./layouts/word.py");
}	else if(n==7||n==8||n==9);
	else dprintf(2,"unrecognized key pressed: %d %s\n",n,name)
;
}int main(int argc,char **argv)
{	XEvent ev
;
	char *dpy_s;
	dpy= XOpenDisplay(NULL);if(dpy)dpy_s=getenv("DISPLAY");
	if(!dpy)
{		dpy_s=":0";dpy= XOpenDisplay(dpy_s);
}	if(!dpy) return 1;
	if(0)XSetCloseDownMode(dpy,RetainTemporary)
;
	root = DefaultRootWindow(dpy);
	/*man xevent ;man XCreateWindowEvent ;page 185,199*/;
	XGetWindowAttributes(dpy,root,&attr);rootdepth=attr.depth
;
	const bw_=40;const bbw=2;
	#define bw bw_
	int max_w=600,max_h=520;
	char redraw=0,dirty=0;if(1)
{		drw1w=bw*15;drw1h=bw*6;
		drw2=XCreatePixmap(dpy,root,drw1w,drw1h,rootdepth);
		drw1b=XCreatePixmap(dpy,root,drw1w,drw1h,rootdepth);
		drw1=XCreatePixmap(dpy,root,drw1w,drw1h,rootdepth);
}	int w1x,w1y,w1w=drw1w,w1h=drw1h;if(1)
{		w1x=0;w1y=800-w1h;
		w1=XCreateSimpleWindow(dpy,DefaultRootWindow(dpy),w1x,w1y,w1w,w1h,0,0,-1);if(1){char *a="keyb";XStoreName(dpy,w1,a);}attri.override_redirect=1;if(0)XChangeWindowAttributes(dpy, w1, CWOverrideRedirect/*page 31*/, &attri);if(1)
{			XSizeHints hints;hints.flags=USPosition;
			XSetWMNormalHints(dpy, w1, &hints);
}		dontfocus(dpy,w1);
		attri.event_mask=ButtonPressMask|PointerMotionMask|ExposureMask/*;attri.backing_store=WhenMapped*/;
		//StructureNotifyMask|ExposureMask/*|FocusChangeMask*/|VisibilityChangeMask;
		XChangeWindowAttributes(dpy, w1, CWEventMask/*|CWBackingStore*/, &attri);
		//XGetWindowAttributes(dpy,w,&attr);sub_backing_store=attr.backing_store
;
		XMapWindow(dpy,w1);//XSync(dpy,False);sleep(1);
}	if(1)
{		gc1=XCreateGC(dpy,w1,0,0);XSetLineAttributes(dpy,gc1, 1,LineSolid, CapRound, JoinRound);XSetForeground(dpy,gc1,0)
;
}	char *udir=get_udir()
;
	ft_ok=0b11;
	if(FT_Init_FreeType(&ft_lib)){ft_ok=0;dprintf(2,"warning: couldn't load font library\n");};
	FT_Open_Args args;args.flags=FT_OPEN_PATHNAME;args.pathname=strdupf("%s/font",udir);args.driver=0;
	if(ft_ok&&FT_Open_Face(ft_lib,&args,0,&ft_font1)){ft_ok&=~0b10;dprintf(2,"warning: couldn't load font file 1\n");};
	frep(args.pathname,strdupf("%s/font_b",udir));
	if(ft_ok&&FT_Open_Face(ft_lib,&args,0,&ft_font1b)){ft_ok&=~0b01;dprintf(2,"warning: couldn't load font file 1b\n");};
	if(ft_ok!=0b11)return 1
;
	short font1_cw,font1_ch,font1b_cw,font1b_ch;
	font1_cw=12;font1_ch=16 ;font1b_cw=12;font1b_ch=16;
	//font1=font_pic_ft(ft_font1,font1_cw,font1_ch,&font1_rarr);
	font1b=font_pic_ft(ft_font1b,font1b_cw,font1b_ch,&font1b_rarr)
;
	if(0)/*show font image*/
{		int drw1w=w1w,drw1h=max_h;
		XSetForeground(dpy,gc1,-1);XFillRectangle(dpy,drw1, gc1, 0,0,drw1w,drw1h);XSetForeground(dpy,gc1,0);
		x_copy_pic(drw1,0,0,&font1,size_pic(&font1),0/*wh*/)
;}
	#undef bw
	#include "keyb_map.c"
	XSetForeground(dpy,gc1,-1);XFillRectangle(dpy,drw2, gc1, 0,0,drw1w,drw1h);XSetForeground(dpy,gc1,0);
	const bbw2=bbw*2;
	int x=0,y=0;
	int n=0;while(1)
{		if(map[n].ex_w==-1)
{			x=0;y+=bw;
}		else if(map[n].ex_w==-2)break;else
{			int base_w=(2+map[n].ex_w)*bw/2;
			char *s=map[n].disp_s?map[n].disp_s:(map[n].s2?map[n].s2:map[n].s);
			x_font_str1(drw2,x+bbw2,y+bw/2-font1_ch/2,base_w-bbw2*2,&font1b,font1b_rarr,font1b_cw,font1b_ch,s);
			XDrawRectangle(dpy,drw2, gc1,x,y-0,base_w,bw);
			x+=base_w;
}		n+=1;
}	if(0)XCopyArea(dpy,drw2,drw1,gc1,0,0,drw1w,drw1h,0,0);
	if(1){XCopyArea(dpy,drw2,drw1b,gc1,0,0,drw1w,drw1h,0,0);redraw=1;}
;
	//xdo_t *xtool=xdo_new_with_opened_display(dpy,dpy_s,0)
;
	//if(XGrabButton(dpy, /*1, None*/AnyButton,AnyModifier, w, False, ButtonPressMask, GrabModeSync, GrabModeAsync, None, None)) ;//return 1;
	int move_x=-1,move_y=-1;
	while(1)
{		if(XCheckMaskEvent(dpy,~NoEventMask,&ev)==False)
{			if(w1)
{				if(redraw){redraw=0;XCopyArea(dpy,drw1b,drw1,gc1,0,0,drw1w,drw1h,0,0);dirty=1;};
				if(dirty){dirty=0;XCopyArea(dpy,drw1,w1,gc1,0,0,drw1w,drw1h,0,0);};
}			if(ending)
{				XCloseDisplay(dpy)/*maybe this would work in signal handler if threads enabled*/;exit(0);
}			//from_xcurs2();
			usleep(2000/*2 ms*/);continue;//XNextEvent(dpy, &ev);
}		//printf1("ev ");
		if(1||ev.xany.window==root)
{			char press=0;int mx,my;
			if(ev.type==Expose)
{				//draw_all() ;//ev.xexpose;
				//w1=ev.xany.window;
				//char *msg=argv[1];
				//draw_text(dpy,&gc1,drw1,w1,10,10,600-10*2,msg);
				dirty=1;
}			//elif(ev.type==ConfigureNotify);
			//elif(ev.type==DestroyNotify);
			if(ev.type==ButtonPress)
{				if(1||ev.xany.window==w1)
{					char mb=ev.xbutton.button;
					mx=ev.xbutton.x;my=ev.xbutton.y;
					if(0&&mb==3)
{						//XUnmapWindow(dpy,ev.xany.window);w1=0;
						XDestroyWindow(dpy,ev.xany.window);w1=0;
						ending=1;
}					if(mb==1)press=1;
}}			else if(ev.type==MotionNotify)
{				Window w_focus;int revert_to;
				XGetInputFocus(dpy,&w_focus,&revert_to);if(w_focus==w1)
{					mx=ev.xmotion.x;my=ev.xmotion.y;
					int x=mx/bw,y=my/bw;if(x!=move_x||y!=move_y)
{						move_x=x;move_y=y;press=2;
}}}			if(press)
{				int n,n_out=-1;
				int x=0,y=0,base_w;if(1)
{					int n=0;while(1)
{						if(map[n].ex_w==-1)
{							x=0;y+=bw;
}						else if(map[n].ex_w==-2)break;else
{							base_w=(2+map[n].ex_w)*bw/2;
							if(check_rect(x,y-0,base_w,bw,mx,my))
{								n_out=n;break;
}							x+=base_w;
}						n+=1;
}}				n=n_out;
				if(press==1)
{					if(n>=0)
{						signed char mod_res=check_mod(n);
						if(mod_res>=0)
{							mod_res=set_mod(n,!mod_res);
							if(!mod_res)
{								XCopyArea(dpy,drw2,drw1b,gc1,x,y,base_w,bw,x,y);
}							else
{								XDrawRectangle(dpy,drw1b, gc1,x+bbw,y-0+bbw,base_w-bbw*2,bw-bbw*2);
}							redraw=1;
}						else
{							static rect prev_r;if(prev_r.w&&prev_r.h)
{								XCopyArea(dpy,drw2,drw1b,gc1,prev_r.x,prev_r.y,prev_r.w,prev_r.h,prev_r.x,prev_r.y);
}							/*draw_rect x,y-0,base_w,bw*/;
							x_draw_rect_dashed(dpy,drw1b, gc1,x+bbw,y-0+bbw,base_w-bbw*2,bw-bbw*2);
							set_rect(prev_r,x,y,base_w,bw);
							redraw=1
;
}						char *s=map[n].s2?map[n].s2:map[n].s;
						if(/*!strlen(s)*/!s[0])
{							char *d_s=map[n].disp_s?map[n].disp_s:(map[n].s2?map[n].s2:map[n].s);
							if(n==6/*hold*/)
{								int mod_n=-1;while(1)
{									keyb_mods_next(&mod_n);if(mod_n<0)break;
									char *s=map[mod_n].s2?map[mod_n].s2:map[mod_n].s;
									//char *tmp=tolower(strdup(s));s=tmp;
									if(s[0]=='F'&&s[1]=='\0')s="f";
									if(check_mod1(mod_n))
{										char *cmd=strdupf("xdotool keydown '%s'",s);system(cmd);free(cmd);
}									else
{										char *cmd=strdupf("xdotool keyup '%s'",s);system(cmd);free(cmd);
}									//free(s);
}}							else check_other_key(n,d_s);
}						else if(mod_res<0)
{							char *mod_str=strdup("");
							int mod_n=-1;while(1)
{								keyb_mods_next(&mod_n);if(mod_n<0)break;
								char *s=map[mod_n].s2?map[mod_n].s2:map[mod_n].s;
								if(check_mod1(mod_n))frep(mod_str,strdupf("%s%s",mod_str,s));
}							char *a=mod_str;frep(a,strdupf("%s%s",a,s))
;
							//XSync(dpy,False);
							Window xtool_w=0;//w1;while(xtool_w==w1);
							//	xdo_get_focused_window_sane(xtool,&xtool_w);
							//xdo_wait_for_window_focus(xtool,0?xtool_w:w1,0);
							//xdo_get_focused_window_sane(xtool,&xtool_w);
							//xdo_wait_for_window_focus(xtool,0?xtool_w:w1,0);
							//xdo_keysequence(xtool,1?CURRENTWINDOW:xtool_w,a,0?DEFAULT_DELAY:80);
							char *cmd=strdupf("xdotool key --delay 80 '%s'",a);system(cmd);free(cmd);
							//dprintf(2,"key_str %x %s\n",xtool_w,a);
							free(a);
}}}				else if(press==2)
{					if(n<0)
{						move_x=-1;move_y=-1;
}					else
{						char *s=map[n].s2?map[n].s2:map[n].s;
						char *cmd;//=strdupf("xclose -ef %s",tip_w_fn);
						//int ex=system(cmd);free(cmd);
						if(/*ex*/0)
{							char *cmd=strdupf("xclose -punf %s 0 520 600 40 >/dev/null",tip_w_fn);
							system(cmd);free(cmd);
}						char *d_s=map[n].disp_s?map[n].disp_s:(map[n].s2?map[n].s2:map[n].s);
						char *s1="";if(/*strcmp(d_s,s)*/d_s[0]!=s[0])s1=s;
						//dprintf(2,"notify %s %s %s\n",s1,d_s,s);
						if(/*!strlen(s1)*/!s1[0])cmd=strdupf("xclose -uf %s",tip_w_fn);
						else cmd=strdupf("notify -f %s 0 520 600 40 '%s' &",tip_w_fn,s1);
						system(cmd);free(cmd);
}}				press=0;
}			//elif(ev.type==VisibilityNotify);
			//	wwvis=ev.xvisibility.state;
}}}//#cpp.py keyboard40 keyb_map pic;gcc keyboard40.c -o keyboard40 -lX11 -lfreetype -I/usr/include/freetype2 -l:libxdo.so.3 -Wall|& gccw|less;
